<?php
global $tmstats;
$tmstats = new TMStats();
Aseco::registerEvent('onNewChallenge', 'tmstatsChalStart');
Aseco::registerEvent('onEndRace', 'tmstatsEndRace');
Aseco::registerEvent('onPlayerFinish', 'tmstatsPlayerFinish');
Aseco::registerEvent('onPlayerConnect', 'tmstatsPlayerConnect');
Aseco::registerEvent('onPlayerDisconnect', 'tmstatsPlayerDisconnect');
Aseco::registerEvent('onPlayerInfoChanged', 'tmstatsPlayerInfoChanged');
Aseco::addChatCommand('stylevote', 'Vote on the track style for TM-Stats.com');

function tmstatsChalStart($aseco, $challenge)
{
	global $tmstats;
	$tmstats->tmstatsChalStart($aseco, $challenge);
}

function tmstatsPlayerFinish($aseco, $finish_item)
{
	global $tmstats;
	$tmstats->tmstatsPlayerFinish($aseco, $finish_item);
}

function tmstatsPlayerConnect($aseco, $player)
{
	global $tmstats;
	$tmstats->tmstatsPlayerConnect($aseco, $player);
}

function tmstatsPlayerDisconnect($aseco, $player)
{
	global $tmstats;
	$tmstats->tmstatsPlayerDisconnect($aseco, $player);
}

function tmstatsPlayerInfoChanged($aseco, $playerinfo)
{
	global $tmstats;
	$tmstats->tmstatsPlayerInfoChanged($aseco, $playerinfo);
}

function chat_stylevote($aseco, $cmd)
{
	global $tmstats;
	$tmstats->chat_stylevote($aseco, $cmd);
}

function tmstatsEndRace($aseco, $race)
{
	global $tmstats;
	$tmstats->tmstatsEndRace($aseco, $race);
}

class TMStats {
	var $times = array();
	var $playerdata = '';
	var $stylevotes = array();
	var $types = array();
	var $environments = array();
	var $realjointimes = array();
	var $stupidleavetimes = array();
	var $stupidjointimes = array();
	
	public function __construct()
	{
		$this->types = array(1 => 'Tech', 2 => 'FullSpeed', 3 => 'Lol', 4 => 'RPG/Trial', 5 => 'Dirt', 6 => 'Other');
		$this->environments = array('Stadium' => 1, 'Rally' => 2, 'Coast' => 3, 'Island' => 4, 'Snow' => 5, 'Desert' => 6, 'Bay' => 7);
	}
	
	public function tmstatsChalStart($aseco, $challenge)
	{
		global $admin_contact;
		$serverdata = htmlspecialchars($aseco->getServerName()).'>'.$aseco->server->port.'>'.$aseco->server->serverlogin.'>'.$admin_contact.'>'.time();
		$challengedata = $aseco->server->challenge->uid.'>'.$aseco->server->challenge->name.'>'.$aseco->server->challenge->author.'>'.$aseco->server->challenge->nbchecks.'>'.$this->environments[$aseco->server->challenge->environment];
		$stylevotedata = '';
		foreach($this->stylevotes as $svl => $sv)
		{
			$stylevotedata .= $svl.'>'.$sv.'>';
		}
		if($stylevotedata == '')
		{
			$stylevotedata = 'NULL';
		}
		else
		{
			$stylevotedata = substr($stylevotedata, 0, -1);
		}
		$timedata = '';
		foreach($this->times as $time)
		{
			$cpdata = '';
			if(count($time[1]) > 0)
			{
				foreach($time[1] as $cp)
				{
					$cpdata .= $cp.'>';
				}
				$cpdata = substr($cpdata, 0, -1);
				$timedata .= $time[0].'>'.$cpdata.chr(10);
			}
		}
		$timedata = substr($timedata, 0, -1);
		if($this->playerdata == '')
		{
			$this->playerdata = 'NULL';
		}
		else
		{
			$this->playerdata = substr($this->playerdata, 0, -1);
		}
		$total = $serverdata.chr(10).$this->playerdata.chr(10).$challengedata.chr(10).$stylevotedata.chr(10).$timedata;
		$fp = fsockopen("www.tm-stats.com", 1337, $errno, $errdesc);
		fputs($fp, $total);
		fclose($fp);
		
		$this->playerdata = '';
		$this->stupidleavetimes = array();
		$this->stupidjointimes = array();
		foreach ($aseco->server->players->player_list as $player) {
			$this->tmstatsPlayerConnect($aseco, $player);
		}
		
		$this->times = array();
		$this->stylevotes = array();
	}
	
	public function tmstatsPlayerFinish($aseco, $finish_item)
	{
		global $checkpoints;
		if ($aseco->server->gameinfo->mode == 3 && !$finish_item->new) return;
		if ($finish_item->score == 0) return;
		$this->times[] = array($finish_item->player->login, $checkpoints[$finish_item->player->login]->curr_cps);
	}
	
	public function tmstatsPlayerConnect($aseco, $player, $real = true)
	{
		if(!$player->isspectator)
		{
			if(!isset($this->realjointimes[$player->login]))
			{
				$this->realjointimes[$player->login] = time();
				if(!isset($this->stupidjointimes[$player->login]))
				{
					$this->stupidjointimes[$player->login] = $this->realjointimes[$player->login];//This won't get deleted
				}
			}
			if(isset($this->stupidleavetimes[$player->login]))
			{
				if($this->realjointimes[$player->login] - $this->stupidleavetimes[$player->login] < 120)
				{
					//If left less than 2 minutes ago. Update the old player object instead
					$this->playerdata = str_replace($player->login.'>'.htmlspecialchars($player->nickname).'>'.$this->stupidjointimes[$player->login].'>'.$this->stupidleavetimes[$player->login].'>', $player->login.'>'.htmlspecialchars($player->nickname).'>'.$this->stupidjointimes[$player->login].'>0>', $this->playerdata);
				}
				else
				{
					//Else just make a new player
					$this->playerdata .= $player->login.'>'.htmlspecialchars($player->nickname).'>'.$this->realjointimes[$player->login].'>0>';
				}
			}
			else
			{
				//Player never left so is new(Xai logic ^^)
				$string = $player->login.'>'.htmlspecialchars($player->nickname).'>'.$this->realjointimes[$player->login].'>0>';
				if(stristr($this->playerdata, $string) === false)
				{ 
					$this->playerdata .= $player->login.'>'.htmlspecialchars($player->nickname).'>'.$this->realjointimes[$player->login].'>0>';
				}
			}
		}
	}
	
	public function tmstatsPlayerDisconnect($aseco, $player, $real = true)
	{
		//Check if player still was being tracked
		if(isset($this->realjointimes[$player->login]))
		{
			$time = time();
			$this->playerdata = str_replace($player->login.'>'.htmlspecialchars($player->nickname).'>'.$this->stupidjointimes[$player->login].'>0>', $player->login.'>'.htmlspecialchars($player->nickname).'>'.$this->stupidjointimes[$player->login].'>'.$time.'>', $this->playerdata);
			unset($this->realjointimes[$player->login]);
			$this->stupidleavetimes[$player->login] = $time;
		}
	}
	
	public function tmstatsPlayerInfoChanged($aseco, $playerinfo)
	{
		$player = $aseco->server->players->getPlayer($playerinfo['Login']);
		//var_dump($playerinfo);
		if($playerinfo['SpectatorStatus'] % 10 != 0 || $playerinfo['SpectatorStatus'] == 2550010)
		{
			tmstatsPlayerDisconnect($aseco, $player, false);
		}
		else
		{
			tmstatsPlayerConnect($aseco, $player, false);
		}
	}
	
	public function chat_stylevote($aseco, $cmd)
	{
		$player = $cmd['author'];
		$parameters = $cmd['params'];
		if($parameters[0] == '')
		{
			$msg = '{#server}Use: /stylevote {idhere}';
			$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($msg), $player->login);
			$msg = '{#server}Styles you can vote on: ';
			foreach($this->types as $id => $name)
			{
				$msg .= $id.' => '.$name. ' and ';
			}
			$msg = substr($msg, 0, -5);
			$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($msg), $player->login);
		}
		else
		{
			if(isset($this->types[$parameters[0]]))
			{
				$this->stylevotes[$player->login] = $parameters[0];
				$msg = '{#server}You succesfully voted for '.$this->types[$parameters[0]];
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($msg), $player->login);
			}
			else
			{
				$msg = '{#error}Style doesn\'t exist, use /stylevote to see all styles';
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors($msg), $player->login);
			}
		}
	}
	
	public function tmstatsEndRace($aseco, $race)
	{
		$msg = '$f0fRemember to vote on this track\'s style. For more info: /stylevote';
		$aseco->client->query('ChatSendServerMessage', $aseco->formatColors($msg));
	}
}
?>